//-----------------------------------------------------------------------------
// Title      : Beispiel fuer EADOGM, EADOGL oder MK3-LCD
//-----------------------------------------------------------------------------
// Funktion   : LCD Test
// Schaltung  : siehe lcd_treiber.h
//-----------------------------------------------------------------------------
// Prozessor  : ATMega2560 oder ATmega644
// Takt       : 16 MHz     oder 20 MHz
//-----------------------------------------------------------------------------
#ifdef ATMEGA644
#define F_CPU 20000000
#else
#define F_CPU 16000000
#endif
#ifdef LCD_SIMULATOR
#include "lcdsim.cc"
#else
#include <avr/io.h>
#endif
#include "lcd_treiber.c"

void linie(int x1,int y1,int dx,int dy)
{
 glcd_cursor(x1,y1);
 glcd_lineto(x1+dx,y1+dy);
}

void beispiel()
{
 int x1=0,y1=0,x2=120,y2=63,x3=127,y3=32,x4=120,y4=2;
 glcd_drawmode(COMPLEMENT);

 //Gefuelltes Viereck zeichnen:
 //glcd_fillbox(0,0,127,63); //Gesamte LCD-Flaeche fuellen
 glcd_fillbox(50,20,117,50);

 //Verzogenes Viereck zeichnen:
 glcd_moveto(x1,y1);
 glcd_lineto(x2,y2);
 glcd_lineto(x3,y3);
 glcd_lineto(x4,y4);
 glcd_lineto(x1,y1);

 //Offenes Dreieck:
 glcd_moveto(10,10);
 glcd_lineto(10,60);
 glcd_lineto(60,60);
 //glcd_lineto(12,12);
 glcd_lineto_last(12,12);

 //Einen Stern zeichnen:
 x1=100; y1=25;
 linie(x1,y1,20,10); //Fall1
 linie(x1,y1,10,20); //Fall2
 linie(x1,y1,-10,20); //Fall3
 linie(x1,y1,-20,10); //Fall4
 linie(x1,y1,-20,-10); //Fall5
 linie(x1,y1,-10,-20); //Fall6
 linie(x1,y1,10,-20); //Fall7
 linie(x1,y1,20,-10); //Fall8
}

int main (void)
{
 //unsigned int n;
 //char led_wert=0;
 //char x,y;
 char x;

#ifdef ATMEGA644
	DDRD |= (1<<5)|(1<<6); //LED1+LED2 auf dem Funkevaluationsboard
#endif

	glcd_init();				// init des LCD
	glcd_clear();				// LCD loeschen
	glcd_licht(true);			// beleuchtung einschalten

	for(x=0;x<3;x++) //test LCD-Hintergrundlicht 3 mal blinken
	 {
	  MILLIWAIT(300);
	  glcd_licht(false);
	  MILLIWAIT(300);
	  glcd_licht(true);			// beleuchtung einschalten
	 }

	beispiel();

	while (true)
	{
#ifdef ATMEGA644
	  PORTD |= (1<<5)|(1<<6); //beide einschalten
	  MILLIWAIT(250); //0.25 Sek lang
	  PORTD &= ~((1<<5)|(1<<6)); //beide aus
#endif
	  MILLIWAIT(250); //0.25 Sek lang
	}
	return 0;
}
